package com.elitesland.demo.controller;

import com.alibaba.excel.EasyExcel;
import com.elitesland.core.base.ApiResult;
import com.elitesland.core.demo.service.DemoService;
import com.elitesland.demo.entity.ExcelDemoDO;
import com.elitesland.demo.repo.ExcelDemoRepo;
import com.elitesland.demo.service.impl.ExcelDemoListener;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import lombok.RequiredArgsConstructor;
import lombok.val;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.Duration;
import java.time.LocalDateTime;
import java.util.Optional;

/**
 * <p>
 * 功能说明
 * </p>
 *
 * @author Mir
 * @date 2020/6/28
 */
@RestController
@RequestMapping("/demo")
@RequiredArgsConstructor
@Api(value = "多模块服务注入", tags = {"多模块服务注入"})
public class DemoController {

    private final DemoService demoService;

    private final ExcelDemoRepo excelDemoRepo;

    @GetMapping
    @ApiOperation("服务注入测试")
    public ResponseEntity<Object> getDemo() {
        if (demoService == null) {
            return ResponseEntity.of(Optional.of("Oops!"));
        }
        return ResponseEntity.of(Optional.of(demoService.add(99, 2)));
    }

    @GetMapping("/excelbatch")
    @ApiOperation("Excel批量导入测试")
    public ApiResult<Long> importExcel() {
        val d = LocalDateTime.now();
        EasyExcel.read("D:\\jpareaddemo.xlsx", ExcelDemoDO.class, new ExcelDemoListener(excelDemoRepo)).sheet().doRead();
        val gap = Duration.between(LocalDateTime.now(), d);
        return ApiResult.ok(gap.getSeconds());
    }
}
