package com.elitesland.demo.controller;

import com.elitesland.core.base.ApiResult;
import com.elitesland.demo.param.EmpCompanyQueryParam;
import com.elitesland.demo.service.EmployeeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.val;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 * 功能说明
 * </p>
 *
 * @author Mir
 * @date 2020/6/29
 */
@RestController
@RequestMapping("/demo/employees")
@RequiredArgsConstructor
@Api(value = "多表关联演示", tags = {"多表关联演示"})
public class EmployeeController {

    private final EmployeeService employeeService;

    @PostMapping("/q")
    @ApiOperation("以雇员公司关联查询为例")
    public ApiResult<Object> search(@RequestBody EmpCompanyQueryParam param) {
        val ret = employeeService.searchWithCompany(param);

        return ApiResult.ok(ret);
    }
}
