package com.elitesland.demo.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;
import com.elitesland.core.base.BaseModel;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Objects;
/**
 * <p>
 * 功能说明
 * </p>
 *
 * @author Mir
 * @date 2020/6/29
 */
@Entity
@Table(name = "tbl_company")
@org.hibernate.annotations.Table(appliesTo = "tbl_company", comment = "JPA演示-公司")
@Data
@Accessors(chain = true)
@ApiModel(value = "JPA演示-公司", description = "JPA演示-公司")
public class CompanyDO extends BaseModel implements Serializable {
    private static final long serialVersionUID = 2480095046239564630L;

    @ApiModelProperty(value = "公司名称")
    @Column(columnDefinition = "varchar(32) default '' comment '公司名称'", nullable = false, unique = true)
    private String companyName;

    @ApiModelProperty(value = "执照编号")
    @Column(columnDefinition = "varchar(32) default '' comment '执照编号'", nullable = false, unique = true)
    private String businessLicense;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof CompanyDO)) {
            return false;
        }
        if (!super.equals(o)) {
            return false;
        }
        CompanyDO entity = (CompanyDO) o;
        return getId().equals(entity.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId());
    }
}
