package com.elitesland.demo.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;
import com.elitesland.core.base.BaseModel;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Objects;
/**
 * <p>
 * 功能说明
 * </p>
 *
 * @author Mir
 * @date 2020/6/29
 */
@Entity
@Table(name = "tbl_employee")
@org.hibernate.annotations.Table(appliesTo = "tbl_employee", comment = "JPA演示-雇员")
@Data
@Accessors(chain = true)
@ApiModel(value = "JPA演示-雇员", description = "JPA演示-雇员")
public class EmployeeDO extends BaseModel implements Serializable {

    private static final long serialVersionUID = 9070053158849073936L;
    @ApiModelProperty(value = "所属公司")
    @Column(columnDefinition = "bigint default 0 comment '所属公司'")
    private Long companyId;

    @ApiModelProperty(value = "姓名")
    @Column(columnDefinition = "varchar(32) default '' comment '姓名'", nullable = false)
    private String name;

    @ApiModelProperty(value = "手机")
    @Column(columnDefinition = "varchar(16) default '' comment '手机'", unique = true)
    private String mobile;

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof EmployeeDO)) {
            return false;
        }
        if (!super.equals(o)) {
            return false;
        }
        EmployeeDO entity = (EmployeeDO) o;
        return getId().equals(entity.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId());
    }
}
