package com.elitesland.demo.service.impl;

import com.elitesland.core.base.PagingVO;
import com.elitesland.demo.param.EmpCompanyQueryParam;
import com.elitesland.demo.repo.EmployeeRepoProc;
import com.elitesland.demo.service.EmployeeService;
import com.elitesland.demo.vo.EmpCompanyVO;
import lombok.RequiredArgsConstructor;
import lombok.val;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 功能说明
 * </p>
 *
 * @author Mir
 * @date 2020/6/29
 */
@Service
@RequiredArgsConstructor
public class EmployeeServiceImpl implements EmployeeService {

    private final EmployeeRepoProc employeeRepoProc;

    @Override
    public PagingVO<EmpCompanyVO> searchWithCompany(EmpCompanyQueryParam param) {

        val emps = employeeRepoProc.select()
                .where(employeeRepoProc.where(param));
        param.fillOrders(emps);
        param.setPaging(emps);

        return PagingVO.<EmpCompanyVO>builder()
                .total(emps.fetchCount())
                .records(emps.fetch())
                .build();
    }
}
