package com.elitesland.demo.service.impl;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.elitesland.demo.entity.ExcelDemoDO;
import com.elitesland.demo.repo.ExcelDemoRepo;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;


/**
 * <p>
 * 功能说明
 * </p>
 *
 * @author Mir
 * @date 2020/6/29
 */
public class ExcelDemoListener extends AnalysisEventListener<ExcelDemoDO> {

    private final ExcelDemoRepo excelDemoRepo;

    private List<ExcelDemoDO> data = new ArrayList<>();

    public static final Integer BATCH_COUNT = 200;

    public ExcelDemoListener(ExcelDemoRepo excelDemoRepo) {
        this.excelDemoRepo = excelDemoRepo;
    }

    @Override
    public void invoke(ExcelDemoDO excelDemoDO, AnalysisContext analysisContext) {
        data.add(excelDemoDO);

        if(data.size() >= BATCH_COUNT){
            saveData();
            data.clear();
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        saveData();
    }

    @Transactional(rollbackFor = {Exception.class})
    void saveData() {
        excelDemoRepo.saveAll(data);
    }
}
